base-files: add 'wifi reconf'
[openwrt/staging/wigyori.git] / package / base-files / files / sbin / wifi
1 #!/bin/sh
2 # Copyright (C) 2006 OpenWrt.org
3
4 . /lib/functions.sh
5 . /usr/share/libubox/jshn.sh
6
7 usage() {
8 cat <<EOF
9 Usage: $0 [config|up|down|reload|status]
10 enables (default), disables or configures devices not yet configured.
11 EOF
12 exit 1
13 }
14
15 ubus_wifi_cmd() {
16 local cmd="$1"
17 local dev="$2"
18
19 json_init
20 [ -n "$2" ] && json_add_string device "$2"
21 ubus call network.wireless "$1" "$(json_dump)"
22 }
23
24 find_net_config() {(
25 local vif="$1"
26 local cfg
27 local ifname
28
29 config_get cfg "$vif" network
30
31 [ -z "$cfg" ] && {
32 include /lib/network
33 scan_interfaces
34
35 config_get ifname "$vif" ifname
36
37 cfg="$(find_config "$ifname")"
38 }
39 [ -z "$cfg" ] && return 0
40 echo "$cfg"
41 )}
42
43
44 bridge_interface() {(
45 local cfg="$1"
46 [ -z "$cfg" ] && return 0
47
48 include /lib/network
49 scan_interfaces
50
51 for cfg in $cfg; do
52 config_get iftype "$cfg" type
53 [ "$iftype" = bridge ] && config_get "$cfg" ifname
54 prepare_interface_bridge "$cfg"
55 return $?
56 done
57 )}
58
59 prepare_key_wep() {
60 local key="$1"
61 local hex=1
62
63 echo -n "$key" | grep -qE "[^a-fA-F0-9]" && hex=0
64 [ "${#key}" -eq 10 -a $hex -eq 1 ] || \
65 [ "${#key}" -eq 26 -a $hex -eq 1 ] || {
66 [ "${key:0:2}" = "s:" ] && key="${key#s:}"
67 key="$(echo -n "$key" | hexdump -ve '1/1 "%02x" ""')"
68 }
69 echo "$key"
70 }
71
72 wifi_fixup_hwmode() {
73 local device="$1"
74 local default="$2"
75 local hwmode hwmode_11n
76
77 config_get channel "$device" channel
78 config_get hwmode "$device" hwmode
79 case "$hwmode" in
80 11bg) hwmode=bg;;
81 11a) hwmode=a;;
82 11b) hwmode=b;;
83 11g) hwmode=g;;
84 11n*)
85 hwmode_11n="${hwmode##11n}"
86 case "$hwmode_11n" in
87 a|g) ;;
88 default) hwmode_11n="$default"
89 esac
90 config_set "$device" hwmode_11n "$hwmode_11n"
91 ;;
92 *)
93 hwmode=
94 if [ "${channel:-0}" -gt 0 ]; then
95 if [ "${channel:-0}" -gt 14 ]; then
96 hwmode=a
97 else
98 hwmode=g
99 fi
100 else
101 hwmode="$default"
102 fi
103 ;;
104 esac
105 config_set "$device" hwmode "$hwmode"
106 }
107
108 _wifi_updown() {
109 for device in ${2:-$DEVICES}; do (
110 config_get disabled "$device" disabled
111 [ "$disabled" = "1" ] && {
112 echo "'$device' is disabled"
113 set disable
114 }
115 config_get iftype "$device" type
116 if eval "type ${1}_$iftype" 2>/dev/null >/dev/null; then
117 eval "scan_$iftype '$device'"
118 eval "${1}_$iftype '$device'" || echo "$device($iftype): ${1} failed"
119 elif [ ! -f /lib/netifd/wireless/$iftype.sh ]; then
120 echo "$device($iftype): Interface type not supported"
121 fi
122 ); done
123 }
124
125 wifi_updown() {
126 cmd=down
127 [ enable = "$1" ] && {
128 _wifi_updown disable "$2"
129 ubus_wifi_cmd "$cmd" "$2"
130 scan_wifi
131 cmd=up
132 }
133 [ reconf = "$1" ] && {
134 scan_wifi
135 cmd=reconf
136 }
137 ubus_wifi_cmd "$cmd" "$2"
138 _wifi_updown "$@"
139 }
140
141 wifi_reload_legacy() {
142 _wifi_updown "disable" "$1"
143 scan_wifi
144 _wifi_updown "enable" "$1"
145 }
146
147 wifi_reload() {
148 ubus call network reload
149 wifi_reload_legacy
150 }
151
152 wifi_detect_notice() {
153 >&2 echo "WARNING: Wifi detect is deprecated. Use wifi config instead"
154 >&2 echo "For more information, see commit 5f8f8a366136a07df661e31decce2458357c167a"
155 exit 1
156 }
157
158 wifi_config() {
159 [ ! -f /etc/config/wireless ] && touch /etc/config/wireless
160
161 for driver in $DRIVERS; do (
162 if eval "type detect_$driver" 2>/dev/null >/dev/null; then
163 eval "detect_$driver" || echo "$driver: Detect failed" >&2
164 else
165 echo "$driver: Hardware detection not supported" >&2
166 fi
167 ); done
168 }
169
170 start_net() {(
171 local iface="$1"
172 local config="$2"
173 local vifmac="$3"
174
175 [ -f "/var/run/$iface.pid" ] && kill "$(cat /var/run/${iface}.pid)" 2>/dev/null
176 [ -z "$config" ] || {
177 include /lib/network
178 scan_interfaces
179 for config in $config; do
180 setup_interface "$iface" "$config" "" "$vifmac"
181 done
182 }
183 )}
184
185 set_wifi_up() {
186 local cfg="$1"
187 local ifname="$2"
188 uci_set_state wireless "$cfg" up 1
189 uci_set_state wireless "$cfg" ifname "$ifname"
190 }
191
192 set_wifi_down() {
193 local cfg="$1"
194 local vifs vif vifstr
195
196 [ -f "/var/run/wifi-${cfg}.pid" ] &&
197 kill "$(cat "/var/run/wifi-${cfg}.pid")" 2>/dev/null
198 uci_revert_state wireless "$cfg"
199 config_get vifs "$cfg" vifs
200 for vif in $vifs; do
201 uci_revert_state wireless "$vif"
202 done
203 }
204
205 scan_wifi() {
206 local cfgfile="$1"
207 DEVICES=
208 config_cb() {
209 local type="$1"
210 local section="$2"
211
212 # section start
213 case "$type" in
214 wifi-device)
215 append DEVICES "$section"
216 config_set "$section" vifs ""
217 config_set "$section" ht_capab ""
218 ;;
219 esac
220
221 # section end
222 config_get TYPE "$CONFIG_SECTION" TYPE
223 case "$TYPE" in
224 wifi-iface)
225 config_get device "$CONFIG_SECTION" device
226 config_get vifs "$device" vifs
227 append vifs "$CONFIG_SECTION"
228 config_set "$device" vifs "$vifs"
229 ;;
230 esac
231 }
232 config_load "${cfgfile:-wireless}"
233 }
234
235 DEVICES=
236 DRIVERS=
237 include /lib/wifi
238 scan_wifi
239
240 case "$1" in
241 down) wifi_updown "disable" "$2";;
242 detect) wifi_detect_notice ;;
243 config) wifi_config ;;
244 status) ubus_wifi_cmd "status" "$2";;
245 reload) wifi_reload "$2";;
246 reload_legacy) wifi_reload_legacy "$2";;
247 --help|help) usage;;
248 reconf) ubus call network reload; wifi_updown "reconf" "$2";;
249 ''|up) ubus call network reload; wifi_updown "enable" "$2";;
250 *) usage; exit 1;;
251 esac